<!DOCTYPE html>
<html lang="fr">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Malédiction de la Dimensionnalité</title>
    <link rel="stylesheet" href="../Css/styles-fr.css">
    <link rel="stylesheet" id="themeStylesheet" href="../Css/light-theme.css"> <!-- thème clair par défaut -->
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.12.0/css/all.min.css">
</head>

<script src="https://cdn.plot.ly/plotly-latest.min.js"></script>
<script src="https://cdnjs.cloudflare.com/ajax/libs/jsxgraph/1.3.5/jsxgraphcore.js"></script>
<script src="https://cdn.jsdelivr.net/npm/jsxgraph@1.3.5/dist/jsxgraphcore.js"></script>
<script src="https://d3js.org/d3.v6.min.js"></script>

<body>

    <section class="top-page">
        <header class="header">
            <nav class="nav">
                <li><a href="#intro">Introduction</a></li>
                <li><a href="#demo">Démonstration Interactive</a></li>
                <li><a href="#res">Ressources</a></li>
            </nav>
            <button id="themeSwitch">Changer de Thème</button> <!-- Bouton pour basculer entre les thèmes -->
        </header>
        <select id="langSelect"> <!-- Bouton langue -->
            <option value="fr">Français</option>
            <option value="en">English</option>
        </select>
        <div class="landing-page">
            <h1 class="big-title">Malédiction de la Dimensionnalité</h1>
            <a class="scroll-down" href="#end">Faire Défiler <i class="fas fa-angle-down"></i></a>
        </div>
    </section>

    <section class="intro" id="intro">
        <h2 class="section-title">Introduction</h2>
        <p class="text">
            La "Malédiction de la Dimensionnalité" est un phénomène complexe qui affecte les performances des algorithmes d'apprentissage automatique et de fouille de données lorsqu'ils sont confrontés à des ensembles de données de grande dimension. Ce concept est essentiel pour comprendre les défis auxquels sont confrontés les scientifiques des données et les ingénieurs en apprentissage automatique lorsqu'ils travaillent avec de grands ensembles de données.
        </p>
        <h3 class="text-title">Qu'est-ce que la Dimensionnalité ?</h3>
        <p class="text">
            La dimensionnalité d'un ensemble de données fait référence au nombre de caractéristiques ou de variables qui le composent. Par exemple, dans un ensemble de données bidimensionnel, chaque point de données est défini par deux variables (ou dimensions). À mesure que le nombre de dimensions augmente, l'espace dans lequel les données résident devient vaste et complexe.
        </p>
        <h3 class="text-title">La Malédiction de la Dimensionnalité</h3>
        <p class="text">
            La Malédiction de la Dimensionnalité décrit les phénomènes négatifs qui surviennent lorsque le nombre de dimensions dans un ensemble de données devient très élevé. Ces phénomènes incluent l'augmentation de la raréfaction des données, l'augmentation de la distance entre les points de données et l'augmentation de la complexité des modèles nécessaires pour les traiter efficacement.
        </p>
        <h3 class="text-title">Conséquences et Défis</h3>
        <p class="text">
            La Malédiction de la Dimensionnalité présente plusieurs conséquences et défis importants pour les applications pratiques en science des données :
        </p>
        <p class="text-list">
            Il peut entraîner une augmentation du temps de calcul nécessaire pour l'entraînement des modèles.
        </p>
        <p class="text-list">
            Il peut nécessiter des ensembles de données beaucoup plus importants pour obtenir des performances de modélisation fiables.
        </p>
        <p class="text-list">
            Il peut entraîner une mauvaise généralisation du modèle, en raison du surajustement ou du sous-ajustement aux données.
        </p>
        <p class="text">
            Comprendre ces défis est crucial pour développer des solutions efficaces et des techniques de prétraitement des données pour surmonter la Malédiction de la Dimensionnalité et améliorer les performances des algorithmes d'apprentissage automatique.
        </p>
    </section>


    <section class="demo" id="demo">
        <h2 class="section-title">Démonstration Interactive</h2>
        <div class="text">
            <p>
                Vous trouverez ci-dessous une démonstration interactive pour visualiser les concepts liés à la Malédiction de la Dimensionnalité. Voici une explication de son fonctionnement :
            </p>
        </div>
        <div class="text">
            <h3>1. Sélection des paramètres :</h3>
            <ul>
                <li>
                    <strong>1. Nombre de dimensions :</strong> Le nombre de dimensions de l’hypercube est défini à l'aide du curseur “Dimension”. Ainsi le nombre de coin de l’hypercube sera de 2^dim coins. Attention, pour des raisons de problèmes d’affichage, seuls un certain nombre de coins extérieurs seront échantillonnés, de cette façon nous aurons que le nombre d'échantillons << 2^dim. 
                    Voir la section explication mathématique et principe de l'algorithme pour plus de détails.
                </li>
                <li>
                    <strong>2. Nombre d’échantillons :</strong> Le nombre d’échantillons dans l’affichage est également défini en l’écrivant dans la barre “Nombre d’échantillons”, ce qui détermine le nombre d’échantillons de coins générés dans l’espace situé entre le cercle circonscrit et inscrit (on commencera par afficher les coins les plus extérieurs). On notera que le nombre d’échantillons doit être << 2^dim
                </li>
                <li>
                    <strong>3. Vecteur w :</strong> Le vecteur w à partir duquel le plan de projection par Gram-Schmidt sera construit, est sélectionnable à l’aide du menu déroulant “w”.
                    Voir la section explication mathématique et principe de l'algorithme pour plus de détails.
                </li>
            </ul>
        </div>
        <div class="text">
            <h3>2. Génération de points :</h3>
            <p class="text">
                Lorsque vous ajustez les curseurs pour choisir les paramètres souhaités, les points sont générés de façon aléatoire dans l’hypercube multidimensionnel en fonction des valeurs sélectionnées avec le curseur “Nombre de points”. Une fois la projection sur le plan réalisé on remarquera que les points sont situés à l’intérieur du cercle circonscrit.
                Voir la section explication mathématique et principe de l'algorithme pour plus de détails.
            </p>
        </div>
        <div class="text">
            <h3>3. Histogramme des normes :</h3>
            <p class="text">
                Un histogramme est également généré pour afficher la distribution des normes des points générés. Vous pouvez ajuster le nombre de barres dans l'histogramme à l'aide du curseur ”Nombre de bars”.
            </p>
        </div>

        <p class="text">
            ______________________________________________
        </p>


        
        <head>
            <meta charset="UTF-8">
            <title>Hypercube Projecion Demonstration </title>
            <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/jsxgraph/1.3.5/jsxgraph.css" />
            <style>
        
                #controls {
                    margin-top: 20px;
                    margin-left: 20px; 
                    background-color: #f1f1f1;
                    padding: 20px;
                }
        
                #graphs-container {
                    display: flex; 
                    gap: 20px; 
                    padding-left: 20px; 
                    margin-top: 20px; 
                }
        
                .jxgbox {
                    width: 1000px;
                    height: 1000px; 
                    border: 1px solid black;
                }
        
            </style>
        
        </head>
        <body>
            <div id="controls">
                <label for="dimension">Dimension:</label>
                <input type="number" id="dimension" min="3" max="100" value="3" />
                <label for="samples">Number of Samples:</label>
                <input type="number" id="samples" value="50" /> 
                <button id="refreshButton">Generate New Points</button>
                <!--
                 <input type="file" id="dataUpload" />
                <label for="bins">Number of Bins:</label>
                <input type="number" id="bins" min="1" max="200" value="20" />
                -->
            </div>
            <div id="graphs-container">
                <div id="graph1" class="jxgbox"></div>
            </div>
            <div id="info"></div>
            <script src="https://cdn.plot.ly/plotly-latest.min.js"></script>
            <script src="https://cdnjs.cloudflare.com/ajax/libs/mathjs/9.5.0/math.min.js"></script>
            <script >
            document.addEventListener('DOMContentLoaded', function () {
            
                var currentD, currentN, currentPoints;
            
        
        
                function points(Dim, NumberOfPoints) {
                    let L = [];
                    for (let i = 0; i < NumberOfPoints; i++) {
                        let point = [];
                        for (let j = 0; j < Dim; j++) {
                            point[j] = Math.random() * 2 - 1;
                        }
                        L.push(point);
                    }
                      return L;
                }
            
                
                  
                function signVector(v) {
                  return math.map(v, val => math.sign(val));
                }
        
                
                
                function projectOnPlane(point, plan) {
                    let y1 = math.dot(point, plan[1]);
                    let y2 = math.dot(point, plan[2]);
                      return [y1, y2];
                }    
                
            
                function gramSchmidt(A) {
                    let W = math.multiply(1 / math.norm(A[0]), A[0]);
                    let e1 = math.subtract(A[1], math.multiply(math.dot(A[1], W), W));
                    e1 = math.multiply(1 / math.norm(e1), e1);
                    let e2 = math.subtract(A[2], math.multiply(math.dot(A[2], W), W));
                    e2 = math.subtract(e2, math.multiply(math.dot(e2, e1), e1));
                    e2 = math.multiply(1 / math.norm(e2), e2);
                      return [W, e1, e2];
              }
              
              
            
            
                function outsideSamples(Dim, numSamples, e1, e2) {
              
                    let samplesCorner = [];
                    for (let i = 0; i < numSamples; i++) {
                      let alpha = Math.random() * 2 - 1; 
                      let beta = Math.random() * 2 - 1;      
                      let v = math.add(math.multiply(alpha, e1), math.multiply(beta, e2));      
                      v = signVector(v.map(component => component / math.norm(v)));      
                      samplesCorner.push(v);
                  }      
                        return samplesCorner;
              }
              
              
              
                function scatter(Dim, preGeneratedPoints, numSamples) {
                    let Vect = gramSchmidt(points(Dim, Dim));
                     
                    let samplesPointsCube = outsideSamples(Dim, numSamples, Vect[1], Vect[2]);
                    let samplesPointsCubeProject = samplesPointsCube.map(point => projectOnPlane(point, Vect));
                    
                    let pointsProject = preGeneratedPoints.map(point => projectOnPlane(point, Vect));
            
                    var data = [
                        {
                            x: pointsProject.map(p => p[0]),
                            y: pointsProject.map(p => p[1]),
                            mode: 'markers',
                            type: 'scatter',
                            name: 'Points',
                            marker: { size: 3, color:  'black' }
                        }
                        
                        ,
                        {
                            x: samplesPointsCubeProject.map(p => p[0]),
                            y: samplesPointsCubeProject.map(p => p[1]),
                            mode: 'markers',
                            type: 'scatter',
                            name: 'OutsidePoints',
                            marker: { size: 6, color: 'red' }
                        }
                        
                    ];
                    
                    let layout = {
                        autosize: true,
            
                        title: 'Plot',
                        xaxis: {
                            title: 'X',
                            scaleanchor: "y",
                            scaleratio: 1,
                            gridwidth: 2
                        },
                        yaxis: {
                            title: 'Y',
                            gridwidth: 2
                        },
                        shapes: [
                            {
                                type: 'circle',
                                xref: 'x',
                                yref: 'y',
                                x0: -1,
                                y0: -1,
                                x1: 1,
                                y1: 1,
                                line: {
                                    color: 'blue',
                                    width: 2,
                                },
                            },
                            {
                                type: 'circle',
                                xref: 'x',
                                yref: 'y',
                                x0: -Math.sqrt(Dim),
                                y0: -Math.sqrt(Dim),
                                x1: Math.sqrt(Dim),
                                y1: Math.sqrt(Dim),
                                line: {
                                    color: 'blue',
                                    width: 2,
                                },
                            },
                        ],
                        template: 'plotly_dark',
                        legend: {
                            font: {
                                size: 10
                            }
                        }
                    };
                    
                    
                    Plotly.react('graph1', data, layout);
                    
                }
            
            
            
            function InputValidation() {
            
                var numberOfSamples = parseInt(document.getElementById('samples').value);
            
                    
                if (isNaN(numberOfSamples) || numberOfSamples <= 0) {
                    alert('Please enter a valid number of samples.');
                    return false;
                }
            
                return true;
            }
            
            
            
            
            function SetPoints() {
                if (!InputValidation()) {
                    return;
                }
                currentD = parseInt(document.getElementById('dimension').value);
                currentN = parseInt(document.getElementById('samples').value);
                currentPoints = points(currentD, currentN); 
            
            
            }
            
            
            
            function refresh() {
                if (!InputValidation() || !currentPoints) {
                    return;
                }
                scatter(currentD, currentPoints, currentD*currentD) ; 
            }
            
            
             
            
            
            document.getElementById('dimension').addEventListener('input', SetPoints);
            document.getElementById('samples').addEventListener('input', SetPoints);
            document.getElementById('refreshButton').addEventListener('click', refresh);
            
            SetPoints()
            });  
            </script>
        </body>
        </html>



    </section>

    <section class="res" id="res">
        <h2 class="section-title">Ressources</h2>
        <p></p>
    </section>

    <footer id="end">
        <p class="copyright">&copy; 2024-Malédiction de la Dimensionnalité</p>
        <a href="" class="more">plus</a>
    </footer>
    
    <script src="../JavaScript/Projection_hypercube.js"></script>
    <script src="../JavaScript/Smooth_web_page.js"></script>

</body>
</html>
